texture g_txSrcColor;

sampler2D g_samSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
};

float3 LuminanceConv = {0.9, 1.5, 0.6};
float BurnShift = 2.25;
float BurnScale = 1.0;
float BurnDelay = 1.0;

float4 PostProcessPS0(float2 Tex : TEXCOORD0) : COLOR0
{
    return float4(BurnDelay, 0, 0, 0);
}

float4 PostProcessPS1(float2 Tex : TEXCOORD0) : COLOR0
{
    return float4(max(0, (dot(tex2D(g_samSrcColor, Tex), LuminanceConv) - BurnShift) * BurnScale), 0, 0, 0);
}

float4 PostProcessPS2(float2 Tex : TEXCOORD0) : COLOR0
{
    float Light = tex2D(g_samSrcColor, Tex).r;

    return float4(Light, Light, Light, 1);
}

technique PostProcess
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 PostProcessPS0();
        ZEnable = false;
    }
    pass p1
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 PostProcessPS1();
        ZEnable = false;
    }
    pass p2
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 PostProcessPS2();
        ZEnable = false;
    }
}
