// dllmain.cpp : DLL AvP[ṼGg |Cg`܂B
#include "stdafx.h"
#include "resource.h"

BOOL APIENTRY DllMain(HMODULE, DWORD, LPVOID);
void DLLInit();

// C402B8 Enable NightVision

// 703500 IsGoggleEnable
// 56022C SetSkyColor
// 553A77 Unknown
// 5532D0 Unknown

// 5532D9 Unknown
// 7012E0 SetConstColor

// 7047ED Unknown

// 704ECB Effect
// 704EDA Green
// 7012C7 Mult
// 704EE8 Noise


// C402B9 Enable ThirmalVision

// 560294 SetSkyColor

// 701328 Red Hot
// 701385 Live Red
// 7013D7 Dead Blue


// 70480D Unknown

// 704F38 Effect
// 704F4B Red
// 704F59 Noise

IDirect3DSurface9* pRTSurface = NULL;
IDirect3DTexture9* pRTTexture = NULL;
IDirect3DSurface9* pRTSurfBloom = NULL;
IDirect3DTexture9* pRTTextBloom = NULL;
IDirect3DSurface9* pRTSurfBurn = NULL;
IDirect3DTexture9* pRTTextBurn = NULL;
IDirect3DSurface9** pRTSurfIllum = NULL;
IDirect3DTexture9** pRTTextIllum = NULL;
IDirect3DSurface9* pRTSurfLight = NULL;
IDirect3DTexture9* pRTTextLight = NULL;

IDirect3DVertexDeclaration9* pVertDecl = NULL;

IDirect3DVertexBuffer9* pPriVB;
IDirect3DVertexBuffer9* pSecVB;
IDirect3DVertexBuffer9* pIlmVB;
IDirect3DVertexBuffer9** pMipVB;
IDirect3DVertexBuffer9* pDotVB;

unsigned long dwOldDispMode = -1;

enum CONFIG_TYPE
{
	TYPE_IGNORE,
	TYPE_INT,
	TYPE_FLOAT,
	TYPE_STRING
};

struct SubConfig
{
	const CONFIG_TYPE type;
	const char* name;
	void* value;
	const char* defvalue;
};
struct Config
{
	const char* name;
	SubConfig* config;
	int num;
};

SubConfig gConfig_Global[] = {
	{TYPE_INT,		"LightMapLevel",	NULL, "4"},
	{TYPE_FLOAT,	"BloomMapScale",	NULL, "640.0"},
	{TYPE_FLOAT,	"BloomBlurSize",	NULL, "1.0"}
};
SubConfig gConfig_Night[] = {
	{TYPE_INT,		"EnableProxy",	NULL, "1"},
	{TYPE_INT,		"EnvLight",		NULL, "64"},
	{TYPE_STRING,	"Constant",		NULL, "0.1"},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_FLOAT,	"IntLight",		NULL, "0.5"},
	{TYPE_INT,		"UseNoise",		NULL, "0"},
	{TYPE_STRING,	"EffectFile",	NULL, "night.fx"},
	{TYPE_FLOAT,	"GlayScaleR",	NULL, "0.9"},
	{TYPE_FLOAT,	"GlayScaleG",	NULL, "1.5"},
	{TYPE_FLOAT,	"GlayScaleB",	NULL, "0.6"},
	{TYPE_FLOAT,	"LightScale",	NULL, "1.0"},
	{TYPE_FLOAT,	"BloomShift",	NULL, "1.0"},
	{TYPE_FLOAT,	"BloomScale",	NULL, "2.5"},
	{TYPE_FLOAT,	"BurnShift",	NULL, "2.5"},
	{TYPE_FLOAT,	"BurnScale",	NULL, "1.0"},
	{TYPE_FLOAT,	"BurnDelay",	NULL, "1.0"},
	{TYPE_FLOAT,	"IncDelay",		NULL, "1.0"},
	{TYPE_FLOAT,	"DecDelay",		NULL, "2.5"},
	{TYPE_FLOAT,	"MaxLight",		NULL, "2.5"},
	{TYPE_FLOAT,	"MinLight",		NULL, "0.5"}
};
SubConfig gConfig_Thermal[] = {
	{TYPE_INT,		"EnableProxy",	NULL, "1"},
	{TYPE_INT,		"EnvLight",		NULL, "255"},
	{TYPE_STRING,	"Constant",		NULL, "0.0"},
	{TYPE_STRING,	"AmbLight",		NULL, "0.0"},
	{TYPE_STRING,	"DirLight",		NULL, "0.5"},
	{TYPE_INT,		"SkyTopTm",		NULL, "8"},
	{TYPE_INT,		"SkyBotTm",		NULL, "16"},
	{TYPE_FLOAT,	"LivePedT",		NULL, "1.0"},
	{TYPE_FLOAT,	"DeadPedT",		NULL, "0.25"},
	{TYPE_IGNORE,	NULL,			NULL, NULL},
	{TYPE_INT,		"UseNoise",		NULL, "0"},
	{TYPE_STRING,	"EffectFile",	NULL, "thermal.fx"},
	{TYPE_FLOAT,	"GlayScaleR",	NULL, "1.8"},
	{TYPE_FLOAT,	"GlayScaleG",	NULL, "0.9"},
	{TYPE_FLOAT,	"GlayScaleB",	NULL, "0.3"},
	{TYPE_FLOAT,	"LightScale",	NULL, "1.5"},
	{TYPE_FLOAT,	"BloomShift",	NULL, "1.5"},
	{TYPE_FLOAT,	"BloomScale",	NULL, "1.0"},
	{TYPE_FLOAT,	"BurnShift",	NULL, "2.0"},
	{TYPE_FLOAT,	"BurnScale",	NULL, "1.0"},
	{TYPE_FLOAT,	"BurnDelay",	NULL, "1.0"},
	{TYPE_FLOAT,	"IncDelay",		NULL, "2.5"},
	{TYPE_FLOAT,	"DecDelay",		NULL, "1.0"},
	{TYPE_FLOAT,	"MaxLight",		NULL, "3.0"},
	{TYPE_FLOAT,	"MinLight",		NULL, "0.5"}
};
const Config gConfig[] = {
	{"GLOBAL", gConfig_Global, sizeof(gConfig_Global) / sizeof(SubConfig)},
	{"NIGHT", gConfig_Night, sizeof(gConfig_Night) / sizeof(SubConfig)},
	{"THERMAL", gConfig_Thermal, sizeof(gConfig_Thermal) / sizeof(SubConfig)}
};

class CEffect
{
public:
    LPD3DXEFFECT m_pEffect;              // Effect object for this technique
    D3DXHANDLE   m_hTPostProcess;        // PostProcess technique handle
    D3DXHANDLE   m_hTexScene;            // Handle to the saved scene texture
    D3DXHANDLE   m_hTexLight;            // Handle to the saved light texture
    D3DXHANDLE   m_hF3Luminance;
    D3DXHANDLE   m_hFLightShift;
    D3DXHANDLE   m_hFLightScale;
    D3DXHANDLE   m_hFBloomShift;
    D3DXHANDLE   m_hFBloomScale;
    D3DXHANDLE   m_hFBurnShift;
    D3DXHANDLE   m_hFBurnScale;
    D3DXHANDLE   m_hFBurnDelay;
    D3DXHANDLE   m_hFIncDelay;
    D3DXHANDLE   m_hFDecDelay;
    D3DXHANDLE   m_hFMaxLight;
    D3DXHANDLE   m_hFMinLight;
    D3DXHANDLE   m_hFTexScale;
    D3DXHANDLE   m_hFAdaptTime;

public:
	CEffect(IDirect3DDevice9* pD3DDev, LPCSTR pSrcFile, BOOL bResource)
	{
		HRESULT hr;
		hr = bResource ? D3DXCreateEffectFromResource(pD3DDev, GetModuleHandle("goggle.asi"), pSrcFile, NULL, NULL, 0, NULL, &m_pEffect, NULL) : D3DXCreateEffectFromFile(pD3DDev, pSrcFile, NULL, NULL, 0, NULL, &m_pEffect, NULL);
		switch (hr)
		{
		case D3D_OK:
			break;
		case D3DERR_INVALIDCALL:
			MessageBox(0, pSrcFile, "Failed: D3DERR_INVALIDCALL", 0);
			return;
		case D3DXERR_INVALIDDATA:
			MessageBox(0, pSrcFile, "Failed: D3DXERR_INVALIDDATA", 0);
			return;
		case E_OUTOFMEMORY:
			MessageBox(0, pSrcFile, "Failed: E_OUTOFMEMORY", 0);
			return;
		default:
			{
				char buf[1024];
				sprintf_s(buf, 1024, "Failed: %d", hr);
				MessageBox(0, pSrcFile, buf, 0);
				return;
			}
		}
		m_hTPostProcess = m_pEffect->GetTechniqueByName("PostProcess");
		m_hTexScene = m_pEffect->GetParameterByName(NULL, "g_txSrcColor");
		m_hTexLight = m_pEffect->GetParameterByName(NULL, "g_txSrcLight");
		m_hF3Luminance = m_pEffect->GetParameterByName(NULL, "LuminanceConv");
		m_hFLightShift = m_pEffect->GetParameterByName(NULL, "LightShift");
		m_hFLightScale = m_pEffect->GetParameterByName(NULL, "LightScale");
		m_hFBloomShift = m_pEffect->GetParameterByName(NULL, "BloomShift");
		m_hFBloomScale = m_pEffect->GetParameterByName(NULL, "BloomScale");
		m_hFBurnShift = m_pEffect->GetParameterByName(NULL, "BurnShift");
		m_hFBurnScale = m_pEffect->GetParameterByName(NULL, "BurnScale");
		m_hFBurnDelay = m_pEffect->GetParameterByName(NULL, "BurnDelay");
		m_hFIncDelay = m_pEffect->GetParameterByName(NULL, "IncDelay");
		m_hFDecDelay = m_pEffect->GetParameterByName(NULL, "DecDelay");
		m_hFMaxLight = m_pEffect->GetParameterByName(NULL, "MaxLight");
		m_hFMinLight = m_pEffect->GetParameterByName(NULL, "MinLight");
		m_hFTexScale = m_pEffect->GetParameterByName(NULL, "TexScale");
		m_hFAdaptTime = m_pEffect->GetParameterByName(NULL, "AdaptTime");

		D3DXHANDLE hParamToConvert;
		D3DXHANDLE hAnnotation;
		UINT uParamIndex = 0;
		while (hParamToConvert = m_pEffect->GetParameter(NULL, uParamIndex++))
		{
			if (hAnnotation = m_pEffect->GetAnnotationByName(hParamToConvert, "ConvertPixelsToTexels"))
			{
				LPCSTR szSource;
				m_pEffect->GetString(hAnnotation, &szSource);
				D3DXHANDLE hConvertSource = m_pEffect->GetParameterByName(NULL, szSource);
				if(hConvertSource)
				{
					D3DXPARAMETER_DESC desc;
					m_pEffect->GetParameterDesc(hConvertSource, &desc);
					DWORD cKernel = desc.Bytes / (2 * sizeof(float));

					D3DXVECTOR4 *pvKernel = new D3DXVECTOR4[cKernel];
					if (pvKernel)
					{
						m_pEffect->GetVectorArray(hConvertSource, pvKernel, cKernel);
						for (DWORD i = 0; i < cKernel; i++)
						{
							pvKernel[i].x *= *(float*)&gConfig[0].config[2].value / *(float*)&gConfig[0].config[1].value;
							pvKernel[i].y *= *(float*)&gConfig[0].config[2].value / (float)*(DWORD*)0xC17048/ (float)*(DWORD*)0xC17044 * *(float*)&gConfig[0].config[1].value;
						}
						m_pEffect->SetVectorArray(hParamToConvert, pvKernel, cKernel);

						delete[] pvKernel;
					}
				}
			}
		}
		return;
	}
	~CEffect()
	{
		m_pEffect->Release();
		m_pEffect = NULL;
		return;
	}
	void Lost()
	{
		m_pEffect->OnLostDevice();
	}
	void Reset()
	{
		m_pEffect->OnResetDevice();
	}
};

CEffect* pENight;
CEffect* pEThermal;
CEffect* pEBloom;
CEffect* pEBurn;
CEffect* pELight;

void Reset3D();
long dwReset3DReturn;
void PostProc(CEffect** ppEffect);

long dwLightSample = 4;

long dwNEnvLight;
long dwNIntLight;
long dwNLightVal;

void NEnvLight();
void _stdcall NProxDraw();

long dwTEnvLight;
float fTAmbLight;
float fTDirLight;
long dwTSkyTopTm;
long dwTSkyBotTm;
float fTLivePedT;
float fTDeadPedT;

void TSkyColor();
void TEnvLight();
void TPedLive();
void TPedHot();
void _stdcall TProxDraw();

#define patch(a, v, s) _patch((void*)(a), (void*)(v), (s))
void _patch(void*, void*, int);
#define nop(a, s) _nop((void*)(a), (s))
void _nop(void*, int);
bool check(void*, unsigned char, const char*, bool);
bool _check(void*, unsigned char);

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		DLLInit();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

void DLLInit()
{
	char cPath[MAX_PATH];
	GetModuleFileName(NULL, cPath, MAX_PATH);
	if (strrchr(cPath, '\\')) *(char*)strrchr(cPath, '\\') = '\0';
	strcat_s(cPath, MAX_PATH, "\\goggle.ini");

	char cBuffer[256];
	const unsigned char cJumpNear = 0xEB;
	const unsigned char cJumpShort = 0xE9;
	const unsigned char cMov = 0xB9;
	const unsigned char cCX = 0x89;
	unsigned long pFunc;

	for (int i = 0; i < sizeof(gConfig) / sizeof(Config); i++) for (int j = 0; j < gConfig[i].num; j++)
	{
		if (gConfig[i].config[j].type == TYPE_IGNORE) continue;
		GetPrivateProfileString(gConfig[i].name, gConfig[i].config[j].name, gConfig[i].config[j].defvalue, cBuffer, sizeof(cBuffer), cPath);
		switch (gConfig[i].config[j].type)
		{
		case TYPE_INT:
			*(long*)&(gConfig[i].config[j].value) = atol(cBuffer);
			break;
		case TYPE_FLOAT:
			*(float*)&(gConfig[i].config[j].value) = (float)atof(cBuffer);
			break;
		case TYPE_STRING:
			gConfig[i].config[j].value = calloc(strlen(cBuffer) + 1, sizeof(char));
			strcpy_s((char*)gConfig[i].config[j].value, strlen(cBuffer) + 1, cBuffer);
			break;
		}
	}

	if (check((void*)0x7F8704, 0x68, "Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F8709;
		dwReset3DReturn = 0x7F870D;
		patch(0x7F8704, &cJumpShort, 1);
		patch(0x7F8705, &pFunc, 4);
	} else
	if (check((void*)0x7F86C4, 0x68, "Reset", false))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F86C9;
		dwReset3DReturn = 0x7F86CD;
		patch(0x7F86C4, &cJumpShort, 1);
		patch(0x7F86C5, &pFunc, 4);
	}

	if (*(long*)&(gConfig[1].config[0].value))
	{
		if (check((void*)0x56022C, 0x74, "NightVision - Sky Color", false)) patch(0x56022C, &cJumpNear, 1);

		dwNEnvLight = *(long*)&(gConfig[1].config[1].value);
		if (dwNEnvLight > 0)
		{
			pFunc = (unsigned long)&NEnvLight - 0x7047F4;
			patch(0x7047EF, &cJumpShort, 1);
			patch(0x7047F0, &pFunc, 4);
		} else if (check((void*)0x7047ED, 0x74, "NightVision - Env Light", false)) patch(0x7047ED, &cJumpNear, 1);

		if (('0' <= ((char*)gConfig[1].config[2].value)[0] && ((char*)gConfig[1].config[2].value)[0] <= '9') || ((char*)gConfig[1].config[2].value)[0] == '-')
		{
			float fConstant = (float)atof((char*)gConfig[1].config[2].value);
			if (check((void*)0x735F7F, 0xC7, "NightVision - Constant Color", false)) patch(0x735F83, &fConstant, 4);
			if (check((void*)0x735F87, 0xC7, "NightVision - Constant Color", false)) patch(0x735F8B, &fConstant, 4);
			if (check((void*)0x735F8F, 0xC7, "NightVision - Constant Color", false)) patch(0x735F93, &fConstant, 4);
		} else if (check((void*)0x7012E7, 0x74, "NightVision - Constant Color", false)) patch(0x7012E7, &cJumpNear, 1);

		pFunc = (unsigned long)&NProxDraw - 0x704EDF;
		if (check((void*)0x704EDA, 0xE8, "NightVision - Greenish", false)) patch(0x704EDB, &pFunc, 4);

		if (!*(long*)&gConfig[1].config[10].value) if (check((void*)0x704EE8, 0xE8, "NightVision - Noise", false)) nop(0x704EE8, 5);

		dwNIntLight = *(long*)&(gConfig[1].config[9].value);

		if (check((void*)0x704F24, 0x8B, "NightVision - Initialize", false))
		{
			patch(0x704F24, &cMov, 1);
			patch(0x704F25, &dwNIntLight, 4);
			nop(0x704F29, 1);
		}
		dwNLightVal = 0;
		pFunc = (unsigned long)&dwNLightVal;
		if (check((void*)0x704F2A, 0x89, "NightVision - Initialize", false)) patch(0x704F2C, &pFunc, 4);
	}

	if (*(long*)&(gConfig[2].config[0].value))
	{
		if (check((void*)0x560294, 0x0F, "ThermalVision - Sky Color", false))
		{
			if (('0' <= ((char*)gConfig[2].config[3].value)[0] && ((char*)gConfig[2].config[3].value)[0] <= '9') || ((char*)gConfig[2].config[3].value)[0] == '-')
			{
				fTAmbLight = (float)atof((char*)gConfig[2].config[3].value);
				if (check((void*)0x5602C1, 0xC7, "ThermalVision - Amb Light", false)) patch(0x5602C7, &fTAmbLight, 4);
				if (check((void*)0x5602CB, 0xC7, "ThermalVision - Amb Light", false)) patch(0x5602D1, &fTAmbLight, 4);
				if (check((void*)0x5602D5, 0xC7, "ThermalVision - Amb Light", false)) patch(0x5602DB, &fTAmbLight, 4);
			} else if (check((void*)0x5602C1, 0xC7, "ThermalVision - Amb Light", false)) nop(0x5602C1, 30);
			if (('0' <= ((char*)gConfig[2].config[4].value)[0] && ((char*)gConfig[2].config[4].value)[0] <= '9') || ((char*)gConfig[2].config[4].value)[0] == '-')
			{
				fTDirLight = (float)atof((char*)gConfig[2].config[4].value);
				if (check((void*)0x5602DF, 0xC7, "ThermalVision - Dir Light", false)) patch(0x5602E5, &fTDirLight, 4);
				if (check((void*)0x5602E9, 0xC7, "ThermalVision - Dir Light", false)) patch(0x5602EF, &fTDirLight, 4);
				if (check((void*)0x5602F3, 0xC7, "ThermalVision - Dir Light", false)) patch(0x5602F9, &fTDirLight, 4);
			} else if (check((void*)0x5602DF, 0xC7, "ThermalVision - Dir Light", false)) nop(0x5602DF, 30);
			dwTSkyTopTm = *(long*)&(gConfig[2].config[5].value);
			dwTSkyBotTm = *(long*)&(gConfig[2].config[6].value);
			if (check((void*)0x5602FD, 0x66, "ThermalVision - Sky Color", false))
			{
				pFunc = (unsigned long)&TSkyColor - 0x560302;
				patch(0x5602FD, &cJumpShort, 1);
				patch(0x5602FE, &pFunc, 4);
			}
		}

		dwNEnvLight = *(long*)&(gConfig[2].config[1].value);
		if (dwTEnvLight > 0)
		{
			pFunc = (unsigned long)&TEnvLight - 0x704814;
			patch(0x70480F, &cJumpShort, 1);
			patch(0x704810, &pFunc, 4);
		} else if (check((void*)0x70480D, 0x74, "ThermalVision - Env Light", false)) patch(0x70480D, &cJumpNear, 1);

		if (check((void*)0x70135C, 0x8B, "ThermalVision - Ped Live", false))
		{
			pFunc = (unsigned long)&TPedLive - 0x701361;
			patch(0x70135C, &cJumpShort, 1);
			patch(0x70135D, &pFunc, 4);
		}

		if (check((void*)0x70138D, 0xD9, "ThermalVision - Ped Hot", false))
		{
			pFunc = (unsigned long)&TPedHot - 0x701392;
			patch(0x70138D, &cJumpShort, 1);
			patch(0x70138E, &pFunc, 4);
		}

		if (check((void*)0x7013AA, 0xD9, "ThermalVision - Ped Dead", false)) nop(0x7013AA, 55);

		if (('0' <= ((char*)gConfig[2].config[2].value)[0] && ((char*)gConfig[2].config[2].value)[0] <= '9') || ((char*)gConfig[2].config[2].value)[0] == '-')
		{
			float fConstant = (float)atof((char*)gConfig[2].config[2].value);
			if (check((void*)0x735F2F, 0xC7, "ThermalVision - Constant Color", false)) patch(0x735F33, &fConstant, 4);
			if (check((void*)0x735F37, 0xC7, "ThermalVision - Constant Color", false)) patch(0x735F3B, &fConstant, 4);
			if (check((void*)0x735F3F, 0xC7, "ThermalVision - Constant Color", false)) patch(0x735F43, &fConstant, 4);
		} else if (check((void*)0x701307, 0x74, "ThermalVision - Constant Color", false)) patch(0x701307, &cJumpNear, 1);

		pFunc = (unsigned long)&TProxDraw - 0x704F50;
		if (check((void*)0x704F4B, 0xE8, "ThermalVision - Redish", false)) patch(0x704F4C, &pFunc, 4);

		if (!*(long*)&gConfig[2].config[10].value) if (check((void*)0x704F59, 0xE8, "ThermalVision - Noise", false)) nop(0x704F59, 5);

		fTLivePedT = *(float*)&(gConfig[2].config[7].value);
		fTDeadPedT = *(float*)&(gConfig[2].config[8].value);
	}

	pRTSurfIllum = (IDirect3DSurface9**)calloc(dwLightSample, sizeof(IDirect3DSurface9*));
	pRTTextIllum = (IDirect3DTexture9**)calloc(dwLightSample, sizeof(IDirect3DTexture9*));
	pMipVB = (IDirect3DVertexBuffer9**)calloc(dwLightSample - 1, sizeof(IDirect3DVertexBuffer9*));

	return;
}

struct PPVERT
{
    float x, y, z, rhw;
    float tu, tv;       // Texcoord for post-process source

    const static D3DVERTEXELEMENT9 Decl[4];
};

// Vertex declaration for post-processing
const D3DVERTEXELEMENT9 PPVERT::Decl[4] =
{
    { 0, 0,  D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITIONT, 0 },
    { 0, 16, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD,  0 },
    D3DDECL_END()
};

PPVERT quad[4] =
{
    {-0.5f, -0.5f, 0.5f, 0.0f, 0.0f, 0.0f},
    {-0.5f, -0.5f, 0.5f, 0.0f, 1.0f, 0.0f},
    {-0.5f, -0.5f, 0.5f, 0.0f, 0.0f, 1.0f},
    {-0.5f, -0.5f, 0.5f, 0.0f, 1.0f, 1.0f}
};

const DWORD dwFVF_POST = D3DFVF_XYZRHW | D3DFVF_TEX1;

void _Reset3D()
{
	IDirect3DDevice9* pD3DDev = *(IDirect3DDevice9**)0xC97C28;

	if (pRTSurface) pRTSurface->Release();
	if (pRTTexture) pRTTexture->Release();
	pRTTexture = NULL;
	if (pRTSurfBloom) pRTSurfBloom->Release();
	if (pRTTextBloom) pRTTextBloom->Release();
	pRTTextBloom = NULL;
	if (pRTSurfBurn) pRTSurfBurn->Release();
	if (pRTTextBurn) pRTTextBurn->Release();
	pRTTextBurn = NULL;
	for (int i = 0; i < dwLightSample; i++)
	{
		if (pRTSurfIllum[i]) pRTSurfIllum[i]->Release();
		if (pRTTextIllum[i]) pRTTextIllum[i]->Release();
		pRTTextIllum[i] = NULL;
	}
	if (pRTSurfLight) pRTSurfLight->Release();
	if (pRTTextLight) pRTTextLight->Release();
	pRTTextLight = NULL;
	if (pVertDecl) pVertDecl->Release();
	pVertDecl = NULL;
	if (pPriVB) pPriVB->Release();
	pPriVB = NULL;
	if (pSecVB) pSecVB->Release();
	pSecVB = NULL;
	if (pIlmVB) pIlmVB->Release();
	pIlmVB = NULL;
	for (int i = 0; i < dwLightSample - 1; i++)
	{
		if (pMipVB[i]) pMipVB[i]->Release();
		pMipVB[i] = NULL;
	}
	if (pDotVB) pDotVB->Release();
	pDotVB = NULL;
	if (pENight) pENight->Lost();
	if (pEThermal) pEThermal->Lost();
	if (pEBloom) pEBloom->Lost();
	if (pEBurn) pEBurn->Lost();
	if (pELight) pELight->Lost();
	dwOldDispMode = *(unsigned long*)0xBA681C;

	return;
}

void _Reset3DA()
{
	IDirect3DDevice9* pD3DDev = *(IDirect3DDevice9**)0xC97C28;

	if (pENight) pENight->Reset();
	if (pEThermal) pEThermal->Reset();
	if (pEBloom) pEBloom->Reset();
	if (pEBurn) pEBurn->Reset();
	if (pELight) pELight->Reset();

	return;
}

void __declspec(naked) Reset3D()
{
	__asm
	{
		pushad;
		call _Reset3D;
		popad;
		push 0xC9C040;
		push eax;
		call [ecx+0x40];
		pushad;
		call _Reset3DA;
		popad;
		mov edi, dwReset3DReturn;
		push edi;
		ret;
	}
}

void PostProc(CEffect** ppEffect)
{
	IDirect3DDevice9* pD3DDev = *(IDirect3DDevice9**)0xC97C28;
	IDirect3DSurface9* pOldRTSurf = NULL;
	IDirect3DBaseTexture9* pOldTexture;
	IDirect3DVertexDeclaration9* pOldVDecl;
	HRESULT hr;
	DWORD dwOldFVF;
	DWORD dwSBlend;
	DWORD dwDBlend;
	DWORD dwBlendOp;
	DWORD dwCull;
	IDirect3DVertexBuffer9* pSSData;
	UINT dwSSOffset;
	UINT dwSSSize;
	UINT dwPasses;

	if (!pRTTexture)
	{
		D3DSURFACE_DESC desc;
		(*(IDirect3DSurface9**)0xC98090)->GetDesc(&desc);
		pD3DDev->CreateTexture(desc.Width, desc.Height, 0, D3DUSAGE_RENDERTARGET, desc.Format, D3DPOOL_DEFAULT, &pRTTexture, NULL);
		pRTTexture->GetSurfaceLevel(0, &pRTSurface);
	}
	if (!pRTTextBloom)
	{
		D3DSURFACE_DESC desc;
		(*(IDirect3DSurface9**)0xC98090)->GetDesc(&desc);
		pD3DDev->CreateTexture((UINT)*(float*)&gConfig[0].config[1].value, (UINT)((float)desc.Height / (float)desc.Width * *(float*)&gConfig[0].config[1].value), 0, D3DUSAGE_RENDERTARGET, D3DFMT_R16F, D3DPOOL_DEFAULT, &pRTTextBloom, NULL);
		pRTTextBloom->GetSurfaceLevel(0, &pRTSurfBloom);
	}
	if (!pRTTextBurn)
	{
		D3DSURFACE_DESC desc;
		(*(IDirect3DSurface9**)0xC98090)->GetDesc(&desc);
		pD3DDev->CreateTexture((UINT)*(float*)&gConfig[0].config[1].value, (UINT)((float)desc.Height / (float)desc.Width * *(float*)&gConfig[0].config[1].value), 0, D3DUSAGE_RENDERTARGET, D3DFMT_R16F, D3DPOOL_DEFAULT, &pRTTextBurn, NULL);
		pRTTextBurn->GetSurfaceLevel(0, &pRTSurfBurn);
	}
	for (int i = 0; i < dwLightSample; i++) if (!pRTTextIllum[i])
	{
		pD3DDev->CreateTexture((UINT)pow(4.f, i) * 2, (UINT)pow(4.f, i) * 2, 0, D3DUSAGE_RENDERTARGET, D3DFMT_R16F, D3DPOOL_DEFAULT, &pRTTextIllum[i], NULL);
		pRTTextIllum[i]->GetSurfaceLevel(0, &pRTSurfIllum[i]);
	}
	if (!pRTTextLight)
	{
		pD3DDev->CreateTexture(1, 1, 0, D3DUSAGE_RENDERTARGET, D3DFMT_R16F, D3DPOOL_DEFAULT, &pRTTextLight, NULL);
		pRTTextLight->GetSurfaceLevel(0, &pRTSurfLight);
	}
	if (!pVertDecl)
	{
		pD3DDev->CreateVertexDeclaration(PPVERT::Decl, &pVertDecl);
	}
	if (!pPriVB)
	{
		D3DSURFACE_DESC desc;
        LPVOID pVBData;
		(*(IDirect3DSurface9**)0xC98090)->GetDesc(&desc);
		quad[1].x = (float)desc.Width - .5f;
		quad[2].y = (float)desc.Height - .5f;
		quad[3].x = (float)desc.Width - .5f;
		quad[3].y = (float)desc.Height - .5f;
		pD3DDev->CreateVertexBuffer(sizeof(PPVERT) * 4, D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, 0, D3DPOOL_DEFAULT, &pPriVB, NULL);
        pPriVB->Lock(0, 0, &pVBData, D3DLOCK_DISCARD);
        CopyMemory(pVBData, quad, 4 * sizeof(PPVERT));
        pPriVB->Unlock();
	}
	if (!pSecVB)
	{
		D3DSURFACE_DESC desc;
        LPVOID pVBData;
		(*(IDirect3DSurface9**)0xC98090)->GetDesc(&desc);
		quad[1].x = *(float*)&gConfig[0].config[1].value - .5f;
		quad[2].y = (float)desc.Height / (float)desc.Width * *(float*)&gConfig[0].config[1].value - .5f;
		quad[3].x = *(float*)&gConfig[0].config[1].value - .5f;
		quad[3].y = (float)desc.Height / (float)desc.Width * *(float*)&gConfig[0].config[1].value - .5f;
		pD3DDev->CreateVertexBuffer(sizeof(PPVERT) * 4, D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, 0, D3DPOOL_DEFAULT, &pSecVB, NULL);
        pSecVB->Lock(0, 0, &pVBData, D3DLOCK_DISCARD);
        CopyMemory(pVBData, quad, 4 * sizeof(PPVERT));
        pSecVB->Unlock();
	}
	if (!pIlmVB)
	{
        LPVOID pVBData;
		quad[1].x = pow(4.f, dwLightSample) * .5f - .5f;
		quad[2].y = pow(4.f, dwLightSample) * .5f - .5f;
		quad[3].x = pow(4.f, dwLightSample) * .5f - .5f;
		quad[3].y = pow(4.f, dwLightSample) * .5f - .5f;
		pD3DDev->CreateVertexBuffer(sizeof(PPVERT) * 4, D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, 0, D3DPOOL_DEFAULT, &pIlmVB, NULL);
        pIlmVB->Lock(0, 0, &pVBData, D3DLOCK_DISCARD);
        CopyMemory(pVBData, quad, 4 * sizeof(PPVERT));
        pIlmVB->Unlock();
	}
	for (int i = 0; i < dwLightSample - 1; i++) if (!pMipVB[i])
	{
        LPVOID pVBData;
		quad[1].x = pow(4.f, i) * 2.f - .5f;
		quad[2].y = pow(4.f, i) * 2.f - .5f;
		quad[3].x = pow(4.f, i) * 2.f - .5f;
		quad[3].y = pow(4.f, i) * 2.f - .5f;
		pD3DDev->CreateVertexBuffer(sizeof(PPVERT) * 4, D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, 0, D3DPOOL_DEFAULT, &pMipVB[i], NULL);
        pMipVB[i]->Lock(0, 0, &pVBData, D3DLOCK_DISCARD);
        CopyMemory(pVBData, quad, 4 * sizeof(PPVERT));
        pMipVB[i]->Unlock();
	}
	if (!pDotVB)
	{
        LPVOID pVBData;
		quad[1].x = 0.5f;
		quad[2].y = 0.5f;
		quad[3].x = 0.5f;
		quad[3].y = 0.5f;
		pD3DDev->CreateVertexBuffer(sizeof(PPVERT) * 4, D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, 0, D3DPOOL_DEFAULT, &pDotVB, NULL);
        pDotVB->Lock(0, 0, &pVBData, D3DLOCK_DISCARD);
        CopyMemory(pVBData, quad, 4 * sizeof(PPVERT));
        pDotVB->Unlock();
	}
	if (!pENight)
	{
		char cPath[MAX_PATH];
		GetModuleFileName(NULL, cPath, MAX_PATH);
		if (strrchr(cPath, '\\')) *(char*)strrchr(cPath, '\\') = '\0';
		strcat_s(cPath, MAX_PATH, "\\");
		strcat_s(cPath, MAX_PATH, (char*)gConfig[1].config[11].value);
		pENight = new CEffect(pD3DDev, cPath, FALSE);
	}
	if (!pEThermal)
	{
		char cPath[MAX_PATH];
		GetModuleFileName(NULL, cPath, MAX_PATH);
		if (strrchr(cPath, '\\')) *(char*)strrchr(cPath, '\\') = '\0';
		strcat_s(cPath, MAX_PATH, "\\");
		strcat_s(cPath, MAX_PATH, (char*)gConfig[2].config[11].value);
		pEThermal = new CEffect(pD3DDev, cPath, FALSE);
	}
	if (!pEBloom)
	{
		pEBloom = new CEffect(pD3DDev, MAKEINTRESOURCE(IDR_BLOOM), TRUE);
	}
	if (!pEBurn)
	{
		pEBurn = new CEffect(pD3DDev, MAKEINTRESOURCE(IDR_BURN), TRUE);
	}
	if (!pELight)
	{
		pELight = new CEffect(pD3DDev, MAKEINTRESOURCE(IDR_LIGHT), TRUE);
	}


	hr = pD3DDev->BeginScene();

	pD3DDev->GetRenderTarget(0, &pOldRTSurf);
	pD3DDev->GetTexture(0, &pOldTexture);
    pD3DDev->GetVertexDeclaration(&pOldVDecl);
	pD3DDev->GetFVF(&dwOldFVF);
	pD3DDev->GetRenderState(D3DRS_SRCBLEND, &dwSBlend);
	pD3DDev->GetRenderState(D3DRS_DESTBLEND, &dwDBlend);
	pD3DDev->GetRenderState(D3DRS_BLENDOP, &dwBlendOp);
	pD3DDev->GetRenderState(D3DRS_CULLMODE, &dwCull);
	pD3DDev->GetStreamSource(0, &pSSData, &dwSSOffset, &dwSSSize);


	pD3DDev->SetTexture(0, NULL);
	pD3DDev->SetVertexDeclaration(pVertDecl);
	pD3DDev->SetFVF(dwFVF_POST);
	pD3DDev->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ZERO);
	pD3DDev->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_ADD);
	pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
	pD3DDev->StretchRect(*(IDirect3DSurface9**)0xC98090, NULL, pRTSurface, NULL, D3DTEXF_NONE);

	float fLuminance[3] = {*(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[12].value, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[13].value, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[14].value};
	(*ppEffect)->m_pEffect->SetFloatArray(pEBurn->m_hFLightScale, fLuminance, 3);
	(*ppEffect)->m_pEffect->SetFloat(pEBurn->m_hFLightScale, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[15].value);
	pEBloom->m_pEffect->SetFloatArray(pEBurn->m_hFLightScale, fLuminance, 3);
	pEBloom->m_pEffect->SetFloat(pEBurn->m_hFBloomShift, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[16].value);
	pEBloom->m_pEffect->SetFloat(pEBurn->m_hFBloomScale, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[17].value);
	pEBurn->m_pEffect->SetFloatArray(pEBurn->m_hFLightScale, fLuminance, 3);
	pEBurn->m_pEffect->SetFloat(pEBurn->m_hFBurnShift, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[18].value);
	pEBurn->m_pEffect->SetFloat(pEBurn->m_hFBurnScale, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[19].value);
	pEBurn->m_pEffect->SetFloat(pEBurn->m_hFBurnDelay, *(float*)0xB7CB5C * .04f / *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[20].value);
	pELight->m_pEffect->SetFloatArray(pEBurn->m_hFLightScale, fLuminance, 3);
	pELight->m_pEffect->SetFloat(pEBurn->m_hFIncDelay, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[21].value);
	pELight->m_pEffect->SetFloat(pEBurn->m_hFDecDelay, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[22].value);
	pELight->m_pEffect->SetFloat(pEBurn->m_hFMaxLight, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[23].value);
	pELight->m_pEffect->SetFloat(pEBurn->m_hFMinLight, *(float*)&gConfig[*(char*)0xC402B8 ? 1 : 2].config[24].value);

	pD3DDev->SetRenderTarget(0, pRTSurfIllum[dwLightSample - 1]);
	pD3DDev->SetStreamSource(0, pIlmVB, 0, sizeof(PPVERT));
	pELight->m_pEffect->Begin(&dwPasses, 0);
	pELight->m_pEffect->SetTexture(pELight->m_hTexScene, pRTTexture);
	pELight->m_pEffect->SetTexture(pELight->m_hTexLight, pRTTextLight);
	pELight->m_pEffect->SetFloat(pELight->m_hFTexScale, pow(4.f, -dwLightSample));
	pELight->m_pEffect->BeginPass(0);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pELight->m_pEffect->EndPass();
	pELight->m_pEffect->SetFloat(pELight->m_hFTexScale, pow(4.f, -4));
	pELight->m_pEffect->BeginPass(1);
	for (int i = dwLightSample - 2; i >= 0; i--)
	{
		pD3DDev->SetRenderTarget(0, pRTSurfIllum[i]);
		pD3DDev->SetStreamSource(0, pMipVB[i], 0, sizeof(PPVERT));
		pELight->m_pEffect->SetTexture(pELight->m_hTexScene, pRTTextIllum[i + 1]);
		pELight->m_pEffect->SetFloat(pELight->m_hFTexScale, pow(4.f, -i) * .125f);
		pELight->m_pEffect->CommitChanges();
		pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	}
	pELight->m_pEffect->EndPass();

	pD3DDev->SetRenderTarget(0, pRTSurface);
	pD3DDev->SetStreamSource(0, pPriVB, 0, sizeof(PPVERT));

	pELight->m_pEffect->SetTexture(pELight->m_hTexScene, pRTTexture);
	pELight->m_pEffect->SetTexture(pELight->m_hTexLight, pRTTextLight);
	pELight->m_pEffect->BeginPass(3);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pELight->m_pEffect->EndPass();
	pELight->m_pEffect->End();

	pD3DDev->SetRenderTarget(0, pRTSurfBurn);
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
	pD3DDev->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_REVSUBTRACT);
	pD3DDev->SetStreamSource(0, pSecVB, 0, sizeof(PPVERT));

	pEBurn->m_pEffect->Begin(&dwPasses, 0);
	pEBurn->m_pEffect->SetTexture(pEBloom->m_hTexScene, pRTTextBurn);
	pEBurn->m_pEffect->SetTexture(pEBurn->m_hTexLight, pRTTextLight);
	pEBurn->m_pEffect->BeginPass(0);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pEBurn->m_pEffect->EndPass();

	pD3DDev->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_MAX);

	pEBurn->m_pEffect->SetTexture(pEBloom->m_hTexScene, pRTTexture);
	pEBurn->m_pEffect->BeginPass(1);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pEBurn->m_pEffect->EndPass();

	pD3DDev->SetRenderTarget(0, pRTSurface);
	pD3DDev->SetStreamSource(0, pPriVB, 0, sizeof(PPVERT));
	pD3DDev->SetRenderState(D3DRS_BLENDOP, D3DBLENDOP_ADD);

	pEBurn->m_pEffect->SetTexture(pEBloom->m_hTexScene, pRTTextBurn);
	pEBurn->m_pEffect->BeginPass(2);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pEBurn->m_pEffect->EndPass();
	pEBurn->m_pEffect->End();


	pD3DDev->SetRenderTarget(0, pRTSurfBloom);
	pD3DDev->SetStreamSource(0, pSecVB, 0, sizeof(PPVERT));
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ZERO);

	pEBloom->m_pEffect->Begin(&dwPasses, 0);
	pEBloom->m_pEffect->SetTexture(pEBloom->m_hTexScene, pRTTexture);
	pEBloom->m_pEffect->SetTexture(pEBloom->m_hTexLight, pRTTextLight);
	for (UINT i = 0; i < dwPasses - 1; i++)
	{
		pEBloom->m_pEffect->BeginPass(i);
		pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
		pEBloom->m_pEffect->EndPass();

		pEBloom->m_pEffect->SetTexture(pEBloom->m_hTexScene, pRTTextBloom);
	}
	pEBloom->m_pEffect->End();


	pD3DDev->SetRenderTarget(0, pRTSurface);
	pD3DDev->SetStreamSource(0, pPriVB, 0, sizeof(PPVERT));
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

	pEBloom->m_pEffect->Begin(&dwPasses, 0);
	pEBloom->m_pEffect->SetTexture(pEBloom->m_hTexScene, pRTTextBloom);

	pEBloom->m_pEffect->BeginPass(dwPasses - 1);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pEBloom->m_pEffect->EndPass();
	pEBloom->m_pEffect->End();


	pD3DDev->SetRenderTarget(0, pRTSurface);
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ZERO);

	(*ppEffect)->m_pEffect->Begin(&dwPasses, 0);
	(*ppEffect)->m_pEffect->SetTexture((*ppEffect)->m_hTexLight, pRTTextLight);
	for (UINT i = 0; i < dwPasses; i++)
	{
		if (i == dwPasses - 1) pD3DDev->SetRenderTarget(0, *(IDirect3DSurface9**)0xC98090);

		(*ppEffect)->m_pEffect->SetTexture((*ppEffect)->m_hTexScene, pRTTexture);

		(*ppEffect)->m_pEffect->BeginPass(i);
		pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
		(*ppEffect)->m_pEffect->EndPass();
	}
	(*ppEffect)->m_pEffect->End();

	pD3DDev->SetRenderTarget(0, pRTSurfLight);
	pD3DDev->SetStreamSource(0, pDotVB, 0, sizeof(PPVERT));

	pELight->m_pEffect->SetTexture(pELight->m_hTexScene, pRTTextIllum[0]);
	pELight->m_pEffect->SetFloat(pELight->m_hFTexScale, .5f);
	pELight->m_pEffect->SetFloat(pELight->m_hFAdaptTime, *(float*)0xB7CB5C * .04f);
	pELight->m_pEffect->Begin(&dwPasses, 0);
	pELight->m_pEffect->BeginPass(2);
	pD3DDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	pELight->m_pEffect->EndPass();
	pELight->m_pEffect->End();


	pD3DDev->SetRenderTarget(0, pOldRTSurf);
	if (pOldRTSurf) pOldRTSurf->Release();
	pD3DDev->SetTexture(0, pOldTexture);
	if (pOldTexture) pOldTexture->Release();
	pD3DDev->SetVertexDeclaration(pOldVDecl);
	if (pOldVDecl) pOldVDecl->Release();
	pD3DDev->SetFVF(dwOldFVF);
	pD3DDev->SetRenderState(D3DRS_SRCBLEND, dwSBlend);
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, dwDBlend);
	pD3DDev->SetRenderState(D3DRS_BLENDOP, dwBlendOp);
	pD3DDev->SetRenderState(D3DRS_CULLMODE, dwCull);
	pD3DDev->SetStreamSource(0, pSSData, dwSSOffset, dwSSSize);
	if (pSSData) pSSData->Release();

	if (hr == S_OK) pD3DDev->EndScene();

	return;
}

void __declspec(naked) NEnvLight()
{
	__asm
	{
		mov eax, dwNEnvLight;
		mov bl, al;
		mov [esp+0x0D], al;
		push 0x7047F5;
		ret;
	}
}

void __stdcall NProxDraw()
{
	PostProc(&pENight);

	return;
}

void __declspec(naked) TSkyColor()
{
	__asm
	{
		mov eax, 0xB7C4C4;
		mov ecx, dwTSkyTopTm;
		test ecx, 0x80000000;
		jnz T_SKYTOP;
		mov word ptr [eax+0], cx;
		mov word ptr [eax+2], cx;
		mov word ptr [eax+4], cx;
T_SKYTOP:
		mov ecx, dwTSkyBotTm;
		test ecx, 0x80000000;
		jnz T_SKYBOT;
		mov word ptr [eax+6], cx;
		mov word ptr [eax+8], cx;
		mov word ptr [eax+10], cx;
T_SKYBOT:
		xor eax, eax;
		mov ecx, 0x80;
		push 0x560323;
		ret;
	}
}

void __declspec(naked) TEnvLight()
{
	__asm
	{
		mov eax, dwTEnvLight;
		mov bl, al;
		mov [esp+0x0D], al;
		push 0x704815;
		ret;
	}
}

void __declspec(naked) TPedLive()
{
	__asm
	{
		mov eax, 0x8D50BC;
		mov	edi, dword ptr [eax+4];
		push  edi;
		mov edi, fTLivePedT;
		mov	dword ptr [eax+0], edi;
		mov	dword ptr [eax+4], edi;
		mov	dword ptr [eax+8], edi;
		pop edi;
		push 0x701362;
		ret;
	}
}

void __declspec(naked) TPedHot()
{
	__asm
	{
		fldz;
		fcomp;
		fnstsw ax;
		test ah, 0x41;
		jz T_DEADPED;
		fld fTLivePedT;
		fsub fTDeadPedT;
		fmulp st(1), st(0);
		fadd fTDeadPedT;
		mov eax, 0x8D50BC;
		fst	dword ptr [eax+0];
		fst	dword ptr [eax+4];
		fst	dword ptr [eax+8];
		fstp st(0);
		push 0x7013E1;
		ret;
T_DEADPED:
		fld fTDeadPedT;
		mov eax, 0x8D50BC;
		fst	dword ptr [eax+0];
		fst	dword ptr [eax+4];
		fst	dword ptr [eax+8];
		fstp st(0);
		push 0x7013E1;
		ret;
	}
}

void __stdcall TProxDraw()
{
	PostProc(&pEThermal);

	return;
}

void _patch(void* pAddress, void* pData, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memcpy(pAddress, pData, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

void _nop(void* pAddress, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memset(pAddress, 0x90, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

bool check(void* pAddress, unsigned char cByte, const char* sExp, bool bContinue)
{
	if (_check(pAddress, cByte)) return true;
	if (bContinue) return false;
	char buf[1024];
	sprintf_s(buf, 1024, "An unknown code found at 0x%08X (%s).\nDo you want to continue without this Function?", pAddress, sExp);
	if (MessageBox(0, buf, "Goggle", MB_YESNO | MB_ICONERROR | MB_DEFBUTTON2) == IDNO) ExitProcess(0);
	return false;
}

bool _check(void* pAddress, unsigned char cByte)
{
	unsigned long dwProtect[2];
	unsigned char cValue = cByte;
	VirtualProtect(pAddress, 1, PAGE_EXECUTE_READ, &dwProtect[0]);
	memcpy(&cValue, pAddress, 1);
	VirtualProtect(pAddress, 1, dwProtect[0], &dwProtect[1]);
	return (cValue == cByte);
}
