texture g_txSrcColor;

sampler2D g_samSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
};

float3 LuminanceConv = {0.9, 1.5, 0.6};
float LightScale = 0.75;

float4 PostProcessPS0(float2 Tex : TEXCOORD0) : COLOR0
{
    float Light = dot((float3)tex2D(g_samSrcColor, Tex), LuminanceConv) / LightScale;

    if (Light < 0.60) return float4(Light / 1.2, Light / .6, 0, 1); else
    if (Light < 0.80) return float4(Light * 2.5 - 1, 1, Light * 2.5 - 1.5, 1); else
    return float4(1, 1, Light * 2.5 - 1.5, 1);
}

technique PostProcess
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 PostProcessPS0();
        ZEnable = false;
    }
}
