texture g_txSrcColor;

sampler2D g_samSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
};

float3 LuminanceConv = {1.8, 0.9, 0.3};
float LightScale = 2.0;

float4 PostProcessPS0(float2 Tex : TEXCOORD0) : COLOR0
{
    float Light = dot((float3)tex2D(g_samSrcColor, Tex), LuminanceConv) / LightScale;

    return float4(1 - Light, 1 - Light, 1 - Light, 1);
}

technique PostProcess
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 PostProcessPS0();
        ZEnable = false;
    }
}
