texture g_txSrcColor;

sampler2D g_samSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
};

float3 LuminanceConv = {1.8, 0.9, 0.3};
float LightScale = 2.0;

float4 PostProcessPS0(float2 Tex : TEXCOORD0) : COLOR0
{
    float Light = dot((float3)tex2D(g_samSrcColor, Tex), LuminanceConv) / LightScale;

    if (Light < 0.20) return float4(0, 0, Light * 5, 1); else
    if (Light < 0.30) return float4(0, Light * 7.5 - 1.5, Light * -2.5 + 1.5, 1); else
    if (Light < 0.40) return float4(0, Light * 2.5, Light * -7.5 + 3, 1); else
    if (Light < 0.50) return float4(Light * 10 - 4, 1, 0, 1); else
    if (Light < 0.70) return float4(1, Light * -5 + 3.5, 0, 1); else
    return float4(1, (Light * 20 - 17) / 3, (Light * 20 - 14) / 3, 1);
}

technique PostProcess
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 PostProcessPS0();
        ZEnable = false;
    }
}
